; tabstop=8
;
;
	relaxed on

	org	$d000

	di

	ld	sp,$d000

	ld	a,$d1
	ld	i,a

	ld	a,$40
	out	($fa),a		; S̊荞݂L
	ld	a,$fe
	out	($fb),a		; SUB-CPUȊO̊荞݃xN^0xB8I/O|[g̒lɂ

	ld	bc,$08b7	; 荞݃xN^ݒ
	ld	hl,IntVectorTable
.outloop:
	inc	c
	outi
	jr	nz,.outloop

	ei

	in	a,($fa)
	call	Hex2str
	ld	a,h
	ld	($f000+160),a
	ld	a,l
	ld	($f000+162),a

	in	a,($fb)
	call	Hex2str
	ld	a,h
	ld	($f000+166),a
	ld	a,l
	ld	($f000+168),a

.loop:
	jr	.loop
	ret


IntVectorTable:
	db	$00
	db	$20
	db	$22
	db	$24
	db	$26
	db	$28
	db	$2a
	db	$2c


IntJoystick:
	push	af
	ld	a,'J'
	ld	($f004),a
	pop	af
	ei
	ret

IntVoice:
	push	af
	ld	a,'V'
	ld	($f006),a
	pop	af
	ei
	ret

IntVRTC:
	push	af
	ld	a,'S'
	ld	($f008),a
	pop	af
	ei
	ret

IntRs232c:
	push	af
	ld	a,'2'
	ld	($f00a),a
	pop	af
	ei
	ret

IntPrinter:
	push	af
	ld	a,'P'
	ld	($f00c),a
	pop	af
	ei
	ret

IntEXTINT:
	push	af
	ld	a,'X'
	ld	($f00e),a
	pop	af
	ei
	ret

IntTimer:
	push	af
	ld	a,'T'
	ld	($f010),a
	pop	af
	ei
	ret



;
; L[͊荞
;
IntKeyin:
	push	af
	call	GetSubcpu
	ld	($f000),a
	ld	a,' '
	ld	($f004),a
	ld	($f006),a
	ld	($f008),a
	ld	($f00a),a
	ld	($f00c),a
	ld	($f00e),a
	ld	($f010),a
	pop	af
	ei
	ret



;
; 荞ݏI[iȂj
;
IntDummy:
	ei
	ret

;
; 荞ݏI[if[^PoCgM{Ȃj
;
IntRead1:
	push	af
	call	GetSubcpu
	pop	af
	ei
	ret



;
; TuCPUPoCgf[^M
;
; RETFAreg=Mf[^
;
GetSubcpu:
	ld	a,$0c
	out	($93),a
.wait:
	in	a,($92)
	and	$20
	jr	z,.wait
	ld	a,$0d
	out	($93),a
	in	a,($90)
	ret

;
; 16if[^𕶎iQjɕϊ
;
; IN	Areg:̓f[^
; OUT	HLreg:o͕
;
Hex2str:
	push	af
	and	$0f
	call	Hex2chr
	ld	l,a
	pop	af
	and	$f0
	rrca
	rrca
	rrca
	rrca
	call	Hex2chr
	ld	h,a
	ret

;
; 16if[^𕶎iPjɕϊ
;
; IN	Areg:̓f[^
; OUT	Areg:o͕
;
Hex2chr:
	add	a,'0'
	cp	'0'+10
	ret	c
	add	a,'A'-'0'-10
	ret


	org	$d100

	dw	IntDummy	; $00:dummy
	dw	IntKeyin	; $02:key input
	dw	IntDummy	; $04:rs-232c
	dw	IntDummy	; $06:timer
	dw	IntRead1	; $08:CMT read
	dw	IntDummy	; $0a:dummy
	dw	IntDummy	; $0c:dummy
	dw	IntKeyin	; $0e:key input
	dw	IntKeyin	; $10:key input
	dw	IntDummy	; $12:CMT error
	dw	IntKeyin	; $14:key input
	dw	IntRead1	; $16:game key
	dw	IntDummy	; $18:dummy
	dw	IntDummy	; $1a:dummy
	dw	IntDummy	; $1c:dummy
	dw	IntDummy	; $1e:dummy

	dw	IntJoystick	; $20
	dw	IntTimer	; $22
	dw	IntVoice	; $24
	dw	IntVRTC		; $26
	dw	IntRs232c	; $28
	dw	IntPrinter	; $2a
	dw	IntEXTINT	; $2c


end
